# NVDA リモート
バージョン 2.6

NVDA リモートを使うと、NVDA スクリーンリーダーを実行している他のコンピューターに接続して操作できます。相手が隣の部屋でも地球の裏側でも同じように操作できます。接続は簡単で、新しく覚えるコマンドはごくわずかです。他の人のコンピューターに接続したり、信頼できる他の人に自分のコンピューターの操作を許可したりして、定期的なメンテナンスを実行したり、トラブルに対応したり、トレーニングを提供したりできます。

## 準備

操作する側と、操作を許可する側の、両方のコンピューターで NVDA および NVDA リモート アドオンがインストールされている必要があります。
NVDA および NVDA リモート アドオンのインストールは一般的な手順と同じです。詳しい説明は NVDA ユーザーガイドをお読みください。

## アップデート

NVDAリモートがセキュアデスクトップで使えるように設定されている場合は、このアドオンをアップデートするときに、セキュアデスクトップの環境もアップデートすることをお勧めします。
その手順は、まずアドオンを通常のようにアップデートします。次に NVDA メニュー「設定」「一般設定」を開いて「現在保存されている情報をログオンまたはその他のセキュアスクリーンで使用」ボタンを押します。

## 外部のサーバーを中継してリモートセッションを開始
### 操作を許可する側のコンピューター
1. NVDA メニューから「ツール」「リモート」「接続」を選択 (NVDA+alt+pageUpを押して接続ダイアログを開くこともできます。)
2. 最初のラジオボタンで「クライアント」を選択
3. 2番目のラジオボタンで「このコンピューターの操作を許可」を選択
4. 「ホスト」のエディットフィールドで、接続したい中継サーバーを選びます。例えば nvdaremote.com が利用できます。接続したいサーバーが既定のポート番号を使用していない場合は「ホスト:ポート番号」のような形式でホストを入力します。（例 nvdaremote.com:1234 ）
5. 「鍵」のエディットフィールドで鍵を入力するか、その次の「鍵を作成」ボタンを押します。
この「鍵」はこのコンピューターを操作する側で、入力が必要になる情報です。
操作される側のコンピューターと操作する側のコンピューターは同じ鍵を使わなくてはなりません。
6. OK ボタンを押します。完了するとピッという音と「接続しました」というメッセージが聞こえます。

### 相手を操作する側のコンピューター
1. NVDA メニューから「ツール」「リモート」「接続」を選択
2. 最初のラジオボタンで「クライアント」を選択
3. 2番目のラジオボタンで「相手のコンピューターを操作」を選択
4. 「ホスト」のエディットフィールドで、接続したい中継サーバーを選びます。例えば nvdaremote.com が利用できます。接続したいサーバーが既定のポート番号を使用していない場合は「ホスト:ポート番号」のような形式でホストを入力します。（例 nvdaremote.com:1234 ）
5. 「鍵」のエディットフィールドで鍵を入力するか、その次の「鍵を作成」ボタンを押します。
この「鍵」はこのコンピューターを操作する側で、入力が必要になる情報です。
6. OK ボタンを押します。完了するとピッという音と「接続しました」というメッセージが聞こえます。

### 接続のセキュリティに関する警告
有効なSSL証明書を持たないサーバーに接続すると、接続のセキュリティに関する警告が表示されます。
これは、接続が安全でないことを意味している可能性があります。 
サーバーのフィンガープリントを信頼する場合は、「接続」ボタンで接続するか、
「このサーバーを信頼して接続し、今後このダイアログを表示しない」ボタンを押して接続し、フィンガープリントを信頼できるサーバーのものとして保存します。

## 片方のコンピューターをサーバーとして使う(ダイレクト接続)
「接続」の最初のラジオボタンで片方が「サーバー」を選択すると、外部のサーバーを中継しない接続ができます。
自分と相手のどちらのコンピューターを「サーバー」のモードにするかを選びます。
あなたが選んだモードと逆のモードを相手のコンピューターが選べば、あなたのコンピューターに接続できます。

あなたがサーバーになることを選択すると、「IPアドレスを調べる」ボタンを使って、このコンピューターが外部からアクセスできるIPアドレスを持っているか、
そしてこのアドオンのためのポートが外部から利用できるかどうかを調べます。
ポートチェックがあなたのコンピューターのポート（既定のポート番号は 6837 ）に接続できない場合は警告のメッセージがあります。
ポートに接続できない場合はアクセス許可やポート転送などの設定を確認してください。
注意: アクセス許可やポート転送の設定方法はここでは説明しません。お使いのルーターなどの説明をご確認ください。

「鍵」のフィールドに鍵を入力するか「鍵を作成」ボタンを押してください。操作する側のコンピューターでは、あなたのコンピューターのIPアドレスに加えて、この鍵の情報が必要です。既定のポート番号(6837)を使用しない場合は、相手のコンピューターで「外部IPアドレス:ポート番号」の形式でホストを指定します。

OKボタンを押すと、コンピューターは接続されます。
相手が接続してきたらリモートを使用できます。

## 相手のコンピューターを操作する

リモートの作業を開始すると、相手のコンピューターを操作する側では、ファンクションキー F11 を押して、入力の送信を開始できます。
「相手のコンピューターを操作」と NVDA が読み上げると、操作する側のコンピューターでのキーボードや点字ディスプレイからの入力は、操作を許可した側のコンピューターに送られます。操作する側のコンピューターが点字ディスプレイを使用している場合には、相手からの情報が、操作する側のコンピューターの点字ディスプレイに表示されます。もう一度 F11 キーを押すと、送信を停止して、自分のコンピューターを操作できるようになります。
互換性の問題を回避するために、操作する側とされる側は同じ配列のキーボードでお使いください。

## 接続情報を共有する

他の人に簡単にNVDAリモートで接続してもらうために、リンクを共有するには、NVDAメニュー「ツール」「リモート」「リンクをコピー」を選びます。
あなたが「相手のコンピューターを操作」を選んでいる場合は、このリンクを相手が使用すれば、その相手のコンピューターを操作できるようになります。
あなたが「自分のコンピューターの操作を許可」を選んでいる場合は、このリンクを相手が使用すれば、その相手があなたのコンピューターを操作できるようになります。
このリンクは多くのアプリから自動的に実行できます。しかし、リンクの実行がうまくいかない場合は、このリンクをクリップボードにコピーして Windows の「ファイル名を指定して実行」ダイアログに貼り付けて、OKボタンを押してください。


## Ctrl+Alt+Delの送信
キー入力を送信している状態では Ctrl+Alt+Del の組み合わせを送信することは、普通の操作ではできません。
相手側に Ctrl+Alt+Del キーを送信したいとき、操作される側がセキュアデスクトップで利用できる場合は、NVDA メニューの「Ctrl+Alt+Delを送信」コマンドを利用してください。

## コンピューターを無人で操作する

自分が所有している遠隔地のコンピューターを操作したいことがあります。例えば旅行中に、自宅の外から自宅のコンピューターを操作できたら便利でしょう。または、自宅の部屋にあるコンピューターを職場から操作したいこともあります。このような高度な使い方に役立つ機能を紹介します。

1. NVDAメニューを開いて「ツール」「リモート」「オプション」を選んでEnterキーを押します。
2. 「起動時にサーバーに自動的に接続」をチェックします。
3. 最初のグループのラジオボタンで「外部のサーバーを使用」または「このコンピューターをサーバーにする」を選択します。
4. 次のグループのラジオボタンで「このコンピューターの操作を許可」を選択します。
5. 「このコンピューターをサーバーにする」を選んだ場合は、指定したポート番号（既定のポート番号は6837）で相手のコンピューターからの接続ができなくてはいけません。
6. 「外部のサーバーを使用」を選んだ場合は、サーバーの情報をホストと鍵のフィールドに入力して、TabキーでOKに移動し、Enterキーを押します。「鍵を生成」オプションはこの場合は使用できません。外出先で思い出しやすいようにするためには、覚えやすい鍵を選びます。

高度な使い方として、NVDAリモートを「起動時にサーバーに自動的に接続」と「相手のコンピューターを操作」の組み合わせで使うこともできます。

注意: 「起動時にサーバーに自動的に接続」に関するオプションは NVDA を次回に再起動したときから有効になります。


## 相手からの音声のミュート
相手のコンピューターからの音声を聞きたくない場合は、NVDAメニューの「ツール」「リモート」「相手の音声をミュート」を選んでEnterキーを押してください。


## リモートの終了

リモートの作業を終了するには:

1. 操作する側のコンピューターで  F11 キーを押して入力の送信を停止してください。「自分のコンピューターを操作」というメッセージが聞こえます。「相手のコンピューターを操作」と聞こえたらもう一度 F11 キーを押してください。

2. NVDAメニューを開いて「ツール」「リモート」「切断」を選んで Enter キーを押してください。NVDA+alt+pageDownを押して、リモートセッションから直接切断することもできます。

## クリップボードを送信
「リモート」メニューの「クリップボードを送信」コマンドは、クリップボードのテキストを相手のコンピューターに送信する機能です。
このコマンドを実行すると、自分のクリップボードのテキスト情報が相手のコンピューターのクリップボードに送信されます。

## セキュアデスクトップでリモートを使う

セキュアデスクトップで NVDA リモートを使うためには、アドオンがセキュアデスクトップで実行できるようにインストールしてください。

1. NVDAメニュー「設定」「一般」を選択

2. 「現在保存されている情報をログインまたはその他のセキュアスクリーンで使用」ボタンを押す

3. 設定やアドオンをコピーするかどうかを聞かれるので「はい」を選択。ユーザーアカウント制御のダイアログが表示される場合は操作を許可してください。
4. 設定がコピーされたら OK ボタンを押してください。さらに OK ボタンを押してダイアログを閉じてください。

セキュアデスクトップにNVDAリモートがインストールされている場合、自分がこのコンピューターの操作を相手に許可している場合、
セキュアデスクトップも相手のコンピューターから操作できます。

### SSL証明書のフィンガープリントの削除
信頼していたサーバーのフィンガープリントを信頼しなくなった場合は、「オプション」ダイアログの「すべての信頼済みフィンガープリントを削除] ボタンを押して、信頼済みのフィンガープリントを全て削除できます。

## 貢献者
以下は NVDA リモートのプロジェクトに貢献した人たちの名前です。

* Hai Nguyen Ly
* Chris Westbrook
* Thomas Huebner
* John F Crosotn III
* Darrell Shandrow
* D Williams
* Matthew McCubbin
* Jason Meddaugh
* ABDULAZIZ ALSHMASI.
* Tyler W Kavanaugh
* Casey Mathews
* Babbage B.V.
* Leonard de Ruijter
* NV Access
* Reef Turner

## 更新履歴

### バージョン 2.6

* 接続ダイアログを開くショートカットキーを追加
* ウクライナ語とイタリア語の翻訳の更新
* 新しいクリップボードキュー

### バージョン 2.5

* SSLの安定性を修正
* セキュアデスクトップのサポートを修正
* 接続ダイアログの初期フォーカスを修正
* 相手のコンピューターの音声の一時停止をサポート
* ホストのエディットボックスを、履歴機能付きの編集可能なコンボボックスに変更
* 破損した設定を自動で削除する

### バージョン 2.4

* 音を追加
* NVDA 2021.1のための更新
* 接続するホストの SSL 証明書を確認する

### バージョン 2.3

* Python 3 に移行
* Python 2 のサポートを終了
* NVDA 2019.3で変更されたAPIに対応するための更新
   - 音声出力のリファクタリング
   - 点字ディスプレイの変更


### バージョン 2.2

* IPv6に対応
* NVDA 2018.3をサポート
* モデル固有の点字ディスプレイ ジェスチャのサポート

### バージョン 2.1

* 「このコンピューターの操作を許可」を選択すると、接続が保存されない問題を修正
* クリップボードを送信するためのショートカットキー(ctrl+shift+NVDA+c)を追加
* ブラウズモードでの点字入力をサポート
* 点字ディスプレイ固有のジェスチャをサポート
* ビープ音の再生中にNVDAの操作をブロックしないよう修正


### バージョン 2.0

* 点字ディスプレイ対応
* 共有リンク nvdaremote:// への対応
* ダイアログの表示を画面の中央に揃える
* ポートチェックのサーバーを portcheck.nvdaremote.com に変更
* マスターモードでのサーバーへの自動接続に対応
* ドキュメントの体裁の修正
* プロトコルバージョン２への移行。すべてのリモートのメッセージにオリジンのフィールドを追加
* 将来の修正に備えたコードのクリーンアップ


## NVDA リモートの変更

このリポジトリをクローンして、NVDA リモートに変更を加えることができます。

### サードパーティの依存関係
これらは pip でインストールできます:
* markdown
* scons
* python-gettext

### 配布用にアドオンをパッケージ化するには:

1. コマンドラインを開き、このリポジトリのルートに移動します
2. **scons** コマンドを実行します。 エラーがなければ、作成されたアドオンは現在のディレクトリに配置されます。
